#ifndef __DECODE_HEADER_INCLUDED__
#define __DECODE_HEADER_INCLUDED__

typedef unsigned int proto_id_t;

struct proto_child {
	struct proto_child	*next;
	proto_id_t		id;
	struct proto		*proto;
};

#define proto_request(x, y) {x, y}
#define null_request() {NULL, 0}
struct proto_req {
	char			*name;
	proto_id_t		id;
};

#ifndef __PLUGIN__
/* temporary structure used internally */
struct preq_list {
	struct preq_list	*next;
	struct proto		*proto;
	struct proto_req	*arr;
};
#endif

#define init_proto(x,y) {NULL, NULL, x, y, NULL}
#define init_proto_ex(x,y,z) {NULL, NULL, x, y, z}
#define null_proto() {NULL, NULL, NULL, NULL}
typedef int (*proc_decode)(struct packet *);
typedef int(*proc_dprint)(struct layer*, char *, int);
struct proto {
	struct proto		*next;
	struct proto_child	*children;
	const char		*name;
	proc_decode		decode;
	proc_dprint		print;
};

#ifndef __PLUGIN__
void decode_init(void);
int decode_resolve(struct proto_req *, struct proto *);
int decode_resolve_all(void);

extern struct proto *protos;
extern unsigned int pcount;
#endif

#ifndef __PLUGIN__
int decode_add(struct proto *, struct proto_req *);
struct proto *decode_proto(char *);
struct proto *decode_subproto(char *, unsigned int);
#else
typedef int(*proc_decode_add)(struct proto *, struct proto_req *);
typedef struct proto *(*proc_decode_proto)(char *);
typedef struct proto *(*proc_decode_subproto)(char *, unsigned int);
#endif

extern struct proto pcap_dlt_p;

#endif /* __DECODE_HEADER_INCLUDED__ */
